#ifndef EDITDIALOG_H
#define EDITDIALOG_H

#include <QDialog>

namespace Ui {
	class EditDialog;
}

/**
  A dialog to edit a demo's name, path and description.
 */
class EditDialog : public QDialog {
	Q_OBJECT
	public:
		/**
		  Constructor.
		 */
		EditDialog(QWidget *parent = 0);

		/**
		  Destructor.
		 */
		~EditDialog();


		/**
		  Returns the set name.
		  @returns the name
		 */
		QString getName();

		/**
		  Returns the set file path.
		  @returns the file path
		 */
		QString getFileName();

		/**
		  Returns the set description.
		  @returns the description
		 */
		QString getDescription();

		/**
		  Sets and displays a new name.
		  @param newName the new name
		 */
		void setName(QString newName);

		/**
		  Sets and displays a new file path.
		  @param newFileName the new file path
		 */
		void setFileName(QString newFileName);

		/**
		  Sets and displays a new description.
		  @param newDescription the new description
		 */
		void setDescription(QString newDescription);

	protected:
		void changeEvent(QEvent *e);

	private:
		Ui::EditDialog *ui;

		QString name; /**< Holds the current name */
		QString fileName; /**< Holds the current file path */
		QString description; /**< Holds the current description */

	public slots:
		void acceptButtonClicked(); /**< Closes the dialog and stores all information */
		void searchButtonClicked(); /**< Opens a FileDialog to choose a new path */
};

#endif // EDITDIALOG_H
