#ifndef MAINWINDOW_H
#define MAINWINDOW_H

#include <QMainWindow>
#include <QTableWidget>
//#include <QProcess>


namespace Ui {
	class MainWindow;
}

/**
  This application enables management of the demo-applications.
  Here you can start demos or add them to the list / drop them
  from a list. You can also load prepared lists.
 */
class MainWindow : public QMainWindow {
	Q_OBJECT
	public:

		/**
		  Constructor.
		 */
		MainWindow(QWidget *parent = 0);

		/**
		  Destructor.
		 */
		~MainWindow();

	protected:
		void changeEvent(QEvent *e);

		/**
		  Reimplemented function.
		  This function is needed to provide functionality of
		  the 3 touch-buttons. It catches key-presses.
		 */
		virtual void  keyPressEvent(QKeyEvent *event);

		/**
		  Reimplemented function.
		  This function is needed to provide functionality of
		  the 3 touch-buttons. It catches key-releases.
		 */
		virtual void  keyReleaseEvent(QKeyEvent *event);

	private:
		Ui::MainWindow *ui;

		/**
		  Prepares the tables.
		 */
		void setUpTable(QTableWidget *);
		void initTables();

		bool running;

		/**
		  Loads information into the tables using the xdemreader-class.
		  @param fileName path to the XML-file
		 */
		void loadXML(QString fileName);

		QString fileName; /**< Holds the path to the XML-file */

	public slots:
		void backButtonClicked(); /**< Closes the application */
		void settingsButtonClicked(); /**< Opens a dialog to load/save/edit and create Demo-XML-files. Automatically opens the current file.*/
		void helpButtonClicked(); /**< Opens a help dialog regarding this application */
		void loadButtonClicked(); /**< Opens a FileDialog to load a new XML file */
		void startButtonClicked(); /**< Starts the chosen demo from the demo-list */

		void finishedProgramm(); /**< Reactivates all buttons. Neccessary because of accidently caught button-clicks. */
};

#endif // MAINWINDOW_H
