#include <QtGui>

#include "xdemwriter.h"

XdemWriter::XdemWriter(QTableWidget *tablewidgetIC, QTableWidget *tablewidgetQT) :
	tablewidgetIC(tablewidgetIC), tablewidgetQT(tablewidgetQT)
{
	xml.setAutoFormatting(true);
}

bool XdemWriter::writeFile(QIODevice *device)
{
	xml.setDevice(device);

	xml.writeStartDocument();
	xml.writeDTD("<!DOCTYPE xdem>");
	xml.writeStartElement("xdem");
	xml.writeAttribute("version", "1.0");

	//Write tables
	xml.writeStartElement("ICdemo");
	writeTable(tablewidgetIC);
	xml.writeEndElement();

	xml.writeStartElement("QTdemo");
	writeTable(tablewidgetQT);
	xml.writeEndElement();

	xml.writeEndDocument();

#if 0
	xml.setDevice(device);

	xml.writeStartDocument();
	xml.writeDTD("<!DOCTYPE xbel>");
	xml.writeStartElement("xbel");
	xml.writeAttribute("version", "1.0");
	for (int i = 0; i < treeWidget->topLevelItemCount(); ++i)
		writeItem(treeWidget->topLevelItem(i));

	xml.writeEndDocument();
#endif
	return true;
}

void XdemWriter::writeTable(QTableWidget *table)
{

	for(int i=0; i<=table->rowCount()-1; i++)
	{
		xml.writeStartElement("application");
		xml.writeTextElement("name", table->item(i, 0)->text());
		xml.writeTextElement("location", table->item(i, 1)->text());
		xml.writeTextElement("description", table->item(i, 2)->text());
		if(table->item(i, 3)->text() != NULL)
			xml.writeTextElement("arguments", table->item(i, 2)->text());
		xml.writeEndElement();
	}
#if 0
	QString tagName = item->data(0, Qt::UserRole).toString();
	if (tagName == "folder") {
		bool folded = !treeWidget->isItemExpanded(item);
		xml.writeStartElement(tagName);
		xml.writeAttribute("folded", folded ? "yes" : "no");
		xml.writeTextElement("title", item->text(0));
		for (int i = 0; i < item->childCount(); ++i)
			writeItem(item->child(i));
		xml.writeEndElement();
	} else if (tagName == "bookmark") {
		xml.writeStartElement(tagName);
		if (!item->text(1).isEmpty())
			xml.writeAttribute("href", item->text(1));
		xml.writeTextElement("title", item->text(0));
		xml.writeEndElement();
	} else if (tagName == "separator") {
		xml.writeEmptyElement(tagName);
	}
#endif
}
