#ifndef XDEMWRITER_H
#define XDEMWRITER_H

#include <QXmlStreamWriter>

QT_BEGIN_NAMESPACE
class QTableWidget;
class QTableWidgetItem;
QT_END_NAMESPACE

/**
  This class reads information from the passed QTableWidgets and
  writes it into a specific XML-file.
 */
class XdemWriter
{
	public:

		/**
		  Constructor.
		  @param tablewidgetIC pointer to QTableWidget that holds the IC-Demos
		  @param tableWidgetQT pointer to QTableWidget that holds the QT-Demos
		 */
		XdemWriter(QTableWidget *tablewidgetIC, QTableWidget *tablewidgetQT);

		/**
		  Starts write process and sets version of the XML-file.
		  @param device pointer to IOStream of the XML-file
		  @returns if successfull written to XML
		 */
		bool writeFile(QIODevice *device);

	private:

		void writeTable(QTableWidget *table);
		QTableWidget *tablewidgetIC; /**< Holds the pointer to QTableWidget that holds the IC-Demos */
		QTableWidget *tablewidgetQT; /**< Holds the pointer to QTableWidget that holds the QT-Demos */
		QXmlStreamWriter xml; /**< QXmlStreamWriter used for writing to the XML-file */
};

#endif // XDEMWRITER_H
