#ifndef MAINWINDOW_H
#define MAINWINDOW_H

#include <QMainWindow>

namespace Ui {
	class MainWindow;
}

/**
  A demo that shows how to adjust the LCD-backlight-intensity.
 */
class MainWindow : public QMainWindow {
	Q_OBJECT
	public:

		/**
		  Constructor.
		 */
		MainWindow(QWidget *parent = 0);

		/**
		  Destructor.
		 */
		~MainWindow();

	protected:
		void changeEvent(QEvent *e);

		/**
		  Reimplemented function.
		  Implemented to recognize key-presses.
		 */
		virtual void keyPressEvent(QKeyEvent *);

		/**
		  Reimplemented function.
		  Implemented to recognize key-releases.
		 */
		virtual void keyReleaseEvent(QKeyEvent *);

	private:
		Ui::MainWindow *ui;

		int getIntensity(); /**< Returns current the LCD brightness. */


	public slots:
		void setIntensity(); /**< Updates the LCD brightness. */

		void backButtonClicked(); /**< Closes the demo application. */
		//void settingsButtonClicked();
		void helpButtonClicked(); /**< Opens a help-dialog regarding this demo.*/
		void setDefaultButtonClicked(); /**< Sets the default LCD brightness. */

};

#endif // MAINWINDOW_H
