#ifndef MAINWINDOW_H
#define MAINWINDOW_H

#include "gpio.h"
#include <QMainWindow>


namespace Ui {
	class MainWindow;
}

/**
  This demo shows how to access and control IO's.
 */
class MainWindow : public QMainWindow {
	Q_OBJECT
	public:

		/**
		  Constructor.
		 */
		MainWindow(QWidget *parent = 0);

		/**
		  Destructor.
		 */
		~MainWindow();

	protected:
		void changeEvent(QEvent *e);


		/**
		  Reimplemented function.
		  This function is needed to provide functionality of
		  the 3 touch-buttons. It catches key-presses.
		 */
		virtual void  keyPressEvent(QKeyEvent *event);

		/**
		  Reimplemented function.
		  This function is needed to provide functionality of
		  the 3 touch-buttons. It catches key-releases.
		 */
		virtual void  keyReleaseEvent(QKeyEvent *event);

	private:
		Ui::MainWindow *ui;

		gpio* currentgpio; /**< Holds the value of the currently controlled IO */
		int gpionumber; /**< Holds the number of the currently controlled IO */

	public slots:
		void toggleButtonClicked(); /**< Toggles the IO's value */
		void clearEdit(); /**< Clears all content within the status-log */
		void onButtonClicked(); /**< Switches the IO to 'ON' */
		void offButtonClicked(); /**< Switches the IO to 'OFF' */
		void backButtonClicked(); /**< Closes the demo */
		void settingsButtonClicked(); /**< Opens a settingsdialog where the IO number can be changed */
		void helpButtonClicked(); /** Opens a helpdialog which shows additional information */


};

#endif // MAINWINDOW_H
