#ifndef MAINWINDOW_H
#define MAINWINDOW_H

#include <QMainWindow>

namespace Ui {
	class MainWindow;
}

/**
  A demo that uses the buzzer to implement a simple piano.
 */
class MainWindow : public QMainWindow {
	Q_OBJECT
	public:
		/**
		  Constructor.
		 */
		MainWindow(QWidget *parent = 0);

		/**
		  Destructor.
		 */
		~MainWindow();

	protected:
		void changeEvent(QEvent *e);

		/**
		  Reimplemented function.
		  Implemented for debugging. It catches key-presses and displays
		  them on the debug-console.
		 */
		virtual void  keyPressEvent(QKeyEvent *event);

		/**
		  Reimplemented function.
		  This function is needed to provide functionality of
		  the 3 touch-buttons. It catches key-releases and displays
		  them on the debug-console.
		 */
		virtual void  keyReleaseEvent(QKeyEvent *event);


	private:
		Ui::MainWindow *ui;


	public slots:
		void backButtonClicked(); /**< Closes the Piano-Demo */
		//void settingsButtonClicked();
		void helpButtonClicked(); /**< Opens a help-dialog regarding this demo.*/

		void updateNote(); /**< Updates the played note depending on the pressed button */
		void enableBuzzer(); /**< Enables the buzzer */
		void disableBuzzer(); /**< Disable / mutes the buzzer */

};

#endif // MAINWINDOW_H
