#include "helpdialog.h"
#include "ui_helpdialog.h"
#include "touchbuttons.h"

#include <QtWebKit>
#include <QKeyEvent>
#include <QDebug>

HelpDialog::HelpDialog(QWidget *parent) :
	QDialog(parent),
	ui(new Ui::HelpDialog)
{
	ui->setupUi(this);

	// Set Backgroundcolor: White
	QPalette pal = this->palette();
	pal.setColor(QPalette::Window, Qt::white);
	this->setPalette(pal);

	this->showFullScreen();

	connect(ui->backButton, SIGNAL(clicked()), this, SLOT(backButtonClicked()));
}

void HelpDialog::loadURL(QString url)
{
	ui->htmlView->load(QUrl(url));

}

void HelpDialog::loadFile(QString file)
{
	ui->htmlView->load(QUrl(file));
}

void HelpDialog::backButtonClicked()
{
	this->accept();
}


void HelpDialog::keyPressEvent(QKeyEvent *event)
{
	//qDebug()<<event->key()<<" ("<<event->text()<<") pressed. - helpdialog"<<endl;

	switch(event->key())
	{
		case touchbuttons::Key_Touch_Left:
			ui->settingsButton->setDown(true);
			break;
		case touchbuttons::Key_Touch_Center:
			ui->backButton->setDown(true);
			break;
		case touchbuttons::Key_Touch_Right:
			ui->helpButton->setDown(true);
			break;
		default:
			break;
	}
}

void HelpDialog::keyReleaseEvent(QKeyEvent *event)
{

	//qDebug()<<event->key()<<" ("<<event->text()<<") released. - helpdialog"<<endl;

	switch(event->key())
	{
		case touchbuttons::Key_Touch_Left:
			if(ui->settingsButton->isDown())
			{
				ui->settingsButton->setDown(false);
				ui->settingsButton->click();
			}else{
				ui->settingsButton->setDown(false);
			}
			break;
		case touchbuttons::Key_Touch_Center:
			if(ui->backButton->isDown())
			{
				ui->backButton->setDown(false);
				ui->backButton->click();
			}else{
				ui->backButton->setDown(false);
			}
			break;
		case touchbuttons::Key_Touch_Right:
			if(ui->helpButton->isDown())
			{
				ui->helpButton->setDown(false);
				ui->helpButton->click();
			}else {
				ui->helpButton->setDown(false);
			}
			break;
		default:
			break;
	}

}

HelpDialog::~HelpDialog()
{
	delete ui;
}

void HelpDialog::changeEvent(QEvent *e)
{
	QDialog::changeEvent(e);
	switch (e->type()) {
		case QEvent::LanguageChange:
			ui->retranslateUi(this);
			break;
		default:
			break;
	}
}
