#ifndef HELPDIALOG_H
#define HELPDIALOG_H

#include <QDialog>

namespace Ui {
	class HelpDialog;
}


/**
  A help-dialog which can display a HTML- or textfile.
 */
class HelpDialog : public QDialog {
	Q_OBJECT
	public:
		/**
		  Constructor.
		 */
		HelpDialog(QWidget *parent = 0);

		/**
		  Destructor.
		 */
		~HelpDialog();

		/**
		  Loads HTML- or textfile into the help-Dialog.
		  @param File URL that should be displayed
		  @see loadfile()
		 */
		void loadURL(QString url);
		/**
		  Loads HTML- or textfile into the help-Dialog.
		  @param File URL that should be displayed
		  @see loadURL()
		 */
		void loadFile(QString file);


	protected:
		void changeEvent(QEvent *e);

		/**
		  Reimplemented function.
		  This function is needed to provide functionality of
		  the 3 touch-buttons. It catches key-presses.
		 */
		virtual void  keyPressEvent(QKeyEvent *event);

		/**
		  Reimplemented function.
		  This function is needed to provide functionality of
		  the 3 touch-buttons. It catches key-releases.
		 */
		virtual void  keyReleaseEvent(QKeyEvent *event);

	private:
		Ui::HelpDialog *ui;

	public slots:
		void backButtonClicked(); /**< Closes the help-dialog */
};

#endif // HELPDIALOG_H
