#include <QtGui/QApplication>
#include "mainwindow.h"
#include "touchbuttons.h"

#include <QMouseDriverFactory>
#include <QStyleFactory>
#include <QDir>

int main(int argc, char *argv[])
{
	QApplication a(argc, argv, QApplication::GuiServer);

	QDir dir(QCoreApplication::applicationDirPath());
#if defined(Q_OS_WIN)
	if (dir.dirName().toLower() == "debug" ||
			dir.dirName().toLower() == "release")
	{
		dir.cdUp();
	}
#elif defined(Q_OS_MAC)
	if (dir.dirName() == "MacOS")
	{
		dir.cdUp();
		dir.cdUp();
		dir.cdUp();
	}
#endif
	QDir::setCurrent(dir.absolutePath());

	MainWindow w;
	w.show();

	// Integrate touchbuttons
	touchbuttons t;
	a.installEventFilter(&t);

	// Activate Touchpanel for use in this application.
	// This is necessary, because QT only implements mouse-
	// and keyboard-drivers itself, but no Touch-Drivers.
#if 0
	// this would detect an USB-mouse connected after the start of the program, but
       	// fails on subsequently started programs
	QMouseDriverFactory::create("LinuxInput", "/dev/input/event0:grab=1");
	QMouseDriverFactory::create("Auto", "");
#else
	QMouseDriverFactory::create("Tslib", "/dev/input/event0");
	QMouseDriverFactory::create("LinuxInput", "/dev/input/event1");
#endif

	QApplication::setStyle(QStyleFactory::create("Windows"));

	return a.exec();
}
