#ifndef TOUCHBUTTONS_H
#define TOUCHBUTTONS_H

#include <QObject>
#include <QKeyEvent>


/**
  This class offers an eventfilter for Touchbutton-Input and an Enum to
  name the keys.
 */
class touchbuttons : public QObject
{
	public:
		enum keys{
			Key_Touch_Left = 0x01010101,
			Key_Touch_Center = 0x01010102,
			Key_Touch_Right = 0x01010103,
		};

		/**
		  Constructor.
		 */
		touchbuttons();

		/**
		  EventFilter which translates Touchbutton-signals into well-defined KeyEvents.
		 */
		virtual bool eventFilter(QObject *obj, QEvent *event);

	private:

		bool leftButtonPressed; /**< variable used for left touchbutton */
		bool rightButtonPressed; /**< variable used for right touchbutton */
		bool escapeReleased; /**< variable used for general detection */
};

#endif // TOUCHBUTTONS_H
