DEMOS_VERSION =	1
DEMOS_SOURCE =	Demos-$(DEMOS_VERSION).tar.bz2
DEMOS_SITE =	http://www.ic42.de/Linux-Images
DEMOS_DEPENDENCIES = qt

DEMOS_INSTALL_APPLICATION =

ifeq ($(BR2_PACKAGE_DEMOS_APPCHOOSE),y)
DEMOS_INSTALL_APPLICATION += AppChooser
endif

ifeq ($(BR2_PACKAGE_DEMOS_IO),y)
DEMOS_INSTALL_APPLICATION += IODemo
endif

ifeq ($(BR2_PACKAGE_DEMOS_PIANO),y)
DEMOS_INSTALL_APPLICATION += PianoDemo
endif

ifeq ($(BR2_PACKAGE_DEMOS_BACKLIGHT),y)
DEMOS_INSTALL_APPLICATION += BacklightDemo
endif

ifeq ($(BR2_PACKAGE_DEMOS_DUMMY),y)
DEMOS_INSTALL_APPLICATION += Dummy
endif

define DEMOS_CONFIGURE_CMDS
	(cd $(@D); \
	 	$(TARGET_CONFIGURE_ENV) $(QT_QMAKE))
endef

define DEMOS_BUILD_CMDS
	$(TARGET_MAKE_ENV) $(MAKE) -C $(@D)
endef

ifeq ($(BR2_PACKAGE_DEMOS_APPCHOOSE_AUTOSTART),y)
define DEMOS_INSTALL_APPCHOOSE_AUTOSTART
	grep -q AppChooser $(TARGET_DIR)/etc/inittab || \
		echo "tty1::once:/usr/bin/AppChooser" >> $(TARGET_DIR)/etc/inittab
endef
endif

define DEMOS_INSTALL_TARGET_CMDS
	for app in $(DEMOS_INSTALL_APPLICATION); do \
		cp -dpf $(@D)/$$app/$$app $(TARGET_DIR)/usr/bin; \
	done
	mkdir -p $(TARGET_DIR)/usr/share/in-circuit
	if test "$(findstring AppChooser,$(DEMOS_INSTALL_APPLICATION))"; then \
		cp -dpf $(@D)/AppChooser/demos.xml $(TARGET_DIR)/usr/share/in-circuit; \
		$(DEMOS_INSTALL_APPCHOOSE_AUTOSTART); \
	fi
endef

$(eval $(generic-package))
