#ifndef __ICLIB_DAEMONIZE_H
#define __ICLIB_DAEMONIZE_H

/**
 * This will daemonize the calling process, so it detaches from the calling tty.
 *
 * @param daemonize abort if this isn't true; that way no changes will be done.
 * @param wd new working directory for the process
 * @param in new stdin for the forked process. NULL for none
 * @param out new stdout
 * @param err new stderr
 * @return zero on success; -1 on error
 */
int daemonize(int daemonize, char *wd, char *in, char *out, char *err);

/**
 * Not all of this functionality is needed always. If the process just should
 * detach from its terminal, the following functionality is enough.
 * (It primaly doesn't closes the standard filehandles)
 *
 * @param detach abort if this isn't true
 */
int detach(int detach);

/**
 * If just the filehandles should be changed, this can be achieved by calling
 * the correct function.
 *
 * @param in new stdin
 * @param out new stdout
 * @param err new stderr
 * @return zero on success
 */
int change_stdio(char *in, char *out, char *err);

#endif
