/*
  File autogenerated by gengetopt version 2.18
  generated with the following command:
  gengetopt -F options -C -a icbus_conf -f parser

  The developers of gengetopt consider the fixed text that goes in all
  gengetopt output files to be in the public domain:
  we make no copyright claims on it.
*/

/* If we use autoconf.  */
#ifdef HAVE_CONFIG_H
#include "config.h"
#endif

#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include "getopt.h"

#include "options.h"

const char *icbus_conf_purpose = "the icbus application sets up a given line for use as an icbus";

const char *icbus_conf_usage = "Usage: " PARSER_PACKAGE " [OPTIONS]...";

const char *icbus_conf_help[] = {
  "  -h, --help             Print help and exit",
  "  -V, --version          Print version and exit",
  "  -t, --tty=STRING       Choose the tty to use as bus  (default=`/dev/ttyS0')",
  "  -r, --rs485=INT        Set this to enable/disable RS485-Mode",
  "  -s, --saveconf         Save the actual configuration to a file  (default=off)",
  "  -f, --conffile=STRING  The Configurationfile to use  \n                           (default=`/etc/icbus.conf')",
  "  -D, --detach           Detach from calling terminal  (default=off)",
    0
};

static
void clear_given (struct icbus_conf *args_info);
static
void clear_args (struct icbus_conf *args_info);

static int
parser_internal (int argc, char * const *argv, struct icbus_conf *args_info, int override, int initialize, int check_required, const char *additional_error);

static int
parser_required2 (struct icbus_conf *args_info, const char *prog_name, const char *additional_error);
struct line_list
{
  char * string_arg;
  struct line_list * next;
};

static struct line_list *cmd_line_list = 0;
static struct line_list *cmd_line_list_tmp = 0;

static void
free_cmd_list(void)
{
  /* free the list of a previous call */
  if (cmd_line_list)
    {
      while (cmd_line_list) {
        cmd_line_list_tmp = cmd_line_list;
        cmd_line_list = cmd_line_list->next;
        free (cmd_line_list_tmp->string_arg);
        free (cmd_line_list_tmp);
      }
    }
}


static char *
gengetopt_strdup (const char *s);

static
void clear_given (struct icbus_conf *args_info)
{
  args_info->help_given = 0 ;
  args_info->version_given = 0 ;
  args_info->tty_given = 0 ;
  args_info->rs485_given = 0 ;
  args_info->saveconf_given = 0 ;
  args_info->conffile_given = 0 ;
  args_info->detach_given = 0 ;
}

static
void clear_args (struct icbus_conf *args_info)
{
  args_info->tty_arg = gengetopt_strdup ("/dev/ttyS0");
  args_info->tty_orig = NULL;
  args_info->rs485_orig = NULL;
  args_info->saveconf_flag = 0;
  args_info->conffile_arg = gengetopt_strdup ("/etc/icbus.conf");
  args_info->conffile_orig = NULL;
  args_info->detach_flag = 0;
  
}

static
void init_args_info(struct icbus_conf *args_info)
{
  args_info->help_help = icbus_conf_help[0] ;
  args_info->version_help = icbus_conf_help[1] ;
  args_info->tty_help = icbus_conf_help[2] ;
  args_info->rs485_help = icbus_conf_help[3] ;
  args_info->saveconf_help = icbus_conf_help[4] ;
  args_info->conffile_help = icbus_conf_help[5] ;
  args_info->detach_help = icbus_conf_help[6] ;
  
}

void
parser_print_version (void)
{
  printf ("%s %s\n", PARSER_PACKAGE, PARSER_VERSION);
}

void
parser_print_help (void)
{
  int i = 0;
  parser_print_version ();

  if (strlen(icbus_conf_purpose) > 0)
    printf("\n%s\n", icbus_conf_purpose);

  printf("\n%s\n\n", icbus_conf_usage);
  while (icbus_conf_help[i])
    printf("%s\n", icbus_conf_help[i++]);
}

void
parser_init (struct icbus_conf *args_info)
{
  clear_given (args_info);
  clear_args (args_info);
  init_args_info (args_info);
}

static void
parser_release (struct icbus_conf *args_info)
{
  
  if (args_info->tty_arg)
    {
      free (args_info->tty_arg); /* free previous argument */
      args_info->tty_arg = 0;
    }
  if (args_info->tty_orig)
    {
      free (args_info->tty_orig); /* free previous argument */
      args_info->tty_orig = 0;
    }
  if (args_info->rs485_orig)
    {
      free (args_info->rs485_orig); /* free previous argument */
      args_info->rs485_orig = 0;
    }
  if (args_info->conffile_arg)
    {
      free (args_info->conffile_arg); /* free previous argument */
      args_info->conffile_arg = 0;
    }
  if (args_info->conffile_orig)
    {
      free (args_info->conffile_orig); /* free previous argument */
      args_info->conffile_orig = 0;
    }
  
  clear_given (args_info);
}

int
parser_file_save(const char *filename, struct icbus_conf *args_info)
{
  FILE *outfile;
  int i = 0;

  outfile = fopen(filename, "w");

  if (!outfile)
    {
      fprintf (stderr, "%s: cannot open file for writing: %s\n", PARSER_PACKAGE, filename);
      return EXIT_FAILURE;
    }

  if (args_info->help_given) {
    fprintf(outfile, "%s\n", "help");
  }
  if (args_info->version_given) {
    fprintf(outfile, "%s\n", "version");
  }
  if (args_info->tty_given) {
    if (args_info->tty_orig) {
      fprintf(outfile, "%s=\"%s\"\n", "tty", args_info->tty_orig);
    } else {
      fprintf(outfile, "%s\n", "tty");
    }
  }
  if (args_info->rs485_given) {
    if (args_info->rs485_orig) {
      fprintf(outfile, "%s=\"%s\"\n", "rs485", args_info->rs485_orig);
    } else {
      fprintf(outfile, "%s\n", "rs485");
    }
  }
  if (args_info->saveconf_given) {
    fprintf(outfile, "%s\n", "saveconf");
  }
  if (args_info->conffile_given) {
    if (args_info->conffile_orig) {
      fprintf(outfile, "%s=\"%s\"\n", "conffile", args_info->conffile_orig);
    } else {
      fprintf(outfile, "%s\n", "conffile");
    }
  }
  if (args_info->detach_given) {
    fprintf(outfile, "%s\n", "detach");
  }
  
  fclose (outfile);

  i = EXIT_SUCCESS;
  return i;
}

void
parser_free (struct icbus_conf *args_info)
{
  parser_release (args_info);
}


/* gengetopt_strdup() */
/* strdup.c replacement of strdup, which is not standard */
char *
gengetopt_strdup (const char *s)
{
  char *result = NULL;
  if (!s)
    return result;

  result = (char*)malloc(strlen(s) + 1);
  if (result == (char*)0)
    return (char*)0;
  strcpy(result, s);
  return result;
}

int
parser (int argc, char * const *argv, struct icbus_conf *args_info)
{
  return parser2 (argc, argv, args_info, 0, 1, 1);
}

int
parser2 (int argc, char * const *argv, struct icbus_conf *args_info, int override, int initialize, int check_required)
{
  int result;

  result = parser_internal (argc, argv, args_info, override, initialize, check_required, NULL);

  if (result == EXIT_FAILURE)
    {
      parser_free (args_info);
      exit (EXIT_FAILURE);
    }
  
  return result;
}

int
parser_required (struct icbus_conf *args_info, const char *prog_name)
{
  int result = EXIT_SUCCESS;

  if (parser_required2(args_info, prog_name, NULL) > 0)
    result = EXIT_FAILURE;

  if (result == EXIT_FAILURE)
    {
      parser_free (args_info);
      exit (EXIT_FAILURE);
    }
  
  return result;
}

int
parser_required2 (struct icbus_conf *args_info, const char *prog_name, const char *additional_error)
{
  int error = 0;

  /* checks for required options */
  if (! args_info->tty_given)
    {
      fprintf (stderr, "%s: '--tty' ('-t') option required%s\n", prog_name, (additional_error ? additional_error : ""));
      error = 1;
    }
  
  if (! args_info->conffile_given)
    {
      fprintf (stderr, "%s: '--conffile' ('-f') option required%s\n", prog_name, (additional_error ? additional_error : ""));
      error = 1;
    }
  
  
  /* checks for dependences among options */

  return error;
}

int
parser_internal (int argc, char * const *argv, struct icbus_conf *args_info, int override, int initialize, int check_required, const char *additional_error)
{
  int c;	/* Character of the parsed option.  */

  int error = 0;
  struct icbus_conf local_args_info;

  if (initialize)
    parser_init (args_info);

  parser_init (&local_args_info);

  optarg = 0;
  optind = 0;
  opterr = 1;
  optopt = '?';

  while (1)
    {
      int option_index = 0;
      char *stop_char;

      static struct option long_options[] = {
        { "help",	0, NULL, 'h' },
        { "version",	0, NULL, 'V' },
        { "tty",	1, NULL, 't' },
        { "rs485",	1, NULL, 'r' },
        { "saveconf",	0, NULL, 's' },
        { "conffile",	1, NULL, 'f' },
        { "detach",	0, NULL, 'D' },
        { NULL,	0, NULL, 0 }
      };

      stop_char = 0;
      c = getopt_long (argc, argv, "hVt:r:sf:D", long_options, &option_index);

      if (c == -1) break;	/* Exit from `while (1)' loop.  */

      switch (c)
        {
        case 'h':	/* Print help and exit.  */
          parser_print_help ();
          parser_free (&local_args_info);
          exit (EXIT_SUCCESS);

        case 'V':	/* Print version and exit.  */
          parser_print_version ();
          parser_free (&local_args_info);
          exit (EXIT_SUCCESS);

        case 't':	/* Choose the tty to use as bus.  */
          if (local_args_info.tty_given)
            {
              fprintf (stderr, "%s: `--tty' (`-t') option given more than once%s\n", argv[0], (additional_error ? additional_error : ""));
              goto failure;
            }
          if (args_info->tty_given && ! override)
            continue;
          local_args_info.tty_given = 1;
          args_info->tty_given = 1;
          if (args_info->tty_arg)
            free (args_info->tty_arg); /* free previous string */
          args_info->tty_arg = gengetopt_strdup (optarg);
          if (args_info->tty_orig)
            free (args_info->tty_orig); /* free previous string */
          args_info->tty_orig = gengetopt_strdup (optarg);
          break;

        case 'r':	/* Set this to enable/disable RS485-Mode.  */
          if (local_args_info.rs485_given)
            {
              fprintf (stderr, "%s: `--rs485' (`-r') option given more than once%s\n", argv[0], (additional_error ? additional_error : ""));
              goto failure;
            }
          if (args_info->rs485_given && ! override)
            continue;
          local_args_info.rs485_given = 1;
          args_info->rs485_given = 1;
          args_info->rs485_arg = strtol (optarg, &stop_char, 0);
          if (!(stop_char && *stop_char == '\0')) {
            fprintf(stderr, "%s: invalid numeric value: %s\n", argv[0], optarg);
            goto failure;
          }
          if (args_info->rs485_orig)
            free (args_info->rs485_orig); /* free previous string */
          args_info->rs485_orig = gengetopt_strdup (optarg);
          break;

        case 's':	/* Save the actual configuration to a file.  */
          if (local_args_info.saveconf_given)
            {
              fprintf (stderr, "%s: `--saveconf' (`-s') option given more than once%s\n", argv[0], (additional_error ? additional_error : ""));
              goto failure;
            }
          if (args_info->saveconf_given && ! override)
            continue;
          local_args_info.saveconf_given = 1;
          args_info->saveconf_given = 1;
          args_info->saveconf_flag = !(args_info->saveconf_flag);
          break;

        case 'f':	/* The Configurationfile to use.  */
          if (local_args_info.conffile_given)
            {
              fprintf (stderr, "%s: `--conffile' (`-f') option given more than once%s\n", argv[0], (additional_error ? additional_error : ""));
              goto failure;
            }
          if (args_info->conffile_given && ! override)
            continue;
          local_args_info.conffile_given = 1;
          args_info->conffile_given = 1;
          if (args_info->conffile_arg)
            free (args_info->conffile_arg); /* free previous string */
          args_info->conffile_arg = gengetopt_strdup (optarg);
          if (args_info->conffile_orig)
            free (args_info->conffile_orig); /* free previous string */
          args_info->conffile_orig = gengetopt_strdup (optarg);
          break;

        case 'D':	/* Detach from calling terminal.  */
          if (local_args_info.detach_given)
            {
              fprintf (stderr, "%s: `--detach' (`-D') option given more than once%s\n", argv[0], (additional_error ? additional_error : ""));
              goto failure;
            }
          if (args_info->detach_given && ! override)
            continue;
          local_args_info.detach_given = 1;
          args_info->detach_given = 1;
          args_info->detach_flag = !(args_info->detach_flag);
          break;


        case 0:	/* Long option with no short option */
        case '?':	/* Invalid option.  */
          /* `getopt_long' already printed an error message.  */
          goto failure;

        default:	/* bug: option not considered.  */
          fprintf (stderr, "%s: option unknown: %c%s\n", PARSER_PACKAGE, c, (additional_error ? additional_error : ""));
          abort ();
        } /* switch */
    } /* while */



  if (check_required)
    {
      error += parser_required2 (args_info, argv[0], additional_error);
    }

  parser_release (&local_args_info);

  if ( error )
    return (EXIT_FAILURE);

  return 0;

failure:
  
  parser_release (&local_args_info);
  return (EXIT_FAILURE);
}

#ifndef CONFIG_FILE_LINE_SIZE
#define CONFIG_FILE_LINE_SIZE 2048
#endif
#define ADDITIONAL_ERROR " in configuration file "

#define CONFIG_FILE_LINE_BUFFER_SIZE (CONFIG_FILE_LINE_SIZE+3)
/* 3 is for "--" and "=" */

char my_argv[CONFIG_FILE_LINE_BUFFER_SIZE+1];

int
parser_configfile (char * const filename, struct icbus_conf *args_info, int override, int initialize, int check_required)
{
  FILE* file;
  char linebuf[CONFIG_FILE_LINE_SIZE];
  int line_num = 0;
  int i, result, equal;
  char *fopt, *farg;
  char *str_index;
  size_t len, next_token;
  char delimiter;
  int my_argc = 0;
  char **my_argv_arg;
  char *additional_error;

  /* store the program name */
  cmd_line_list_tmp = (struct line_list *) malloc (sizeof (struct line_list));
  cmd_line_list_tmp->next = cmd_line_list;
  cmd_line_list = cmd_line_list_tmp;
  cmd_line_list->string_arg = gengetopt_strdup (PARSER_PACKAGE);

  if ((file = fopen(filename, "r")) == NULL)
    {
      fprintf (stderr, "%s: Error opening configuration file '%s'\n",
               PARSER_PACKAGE, filename);
      result = EXIT_FAILURE;
      goto conf_failure;
    }

  while ((fgets(linebuf, CONFIG_FILE_LINE_SIZE, file)) != NULL)
    {
      ++line_num;
      my_argv[0] = '\0';
      len = strlen(linebuf);
      if (len > (CONFIG_FILE_LINE_BUFFER_SIZE-1))
        {
          fprintf (stderr, "%s:%s:%d: Line too long in configuration file\n",
                   PARSER_PACKAGE, filename, line_num);
          result = EXIT_FAILURE;
          goto conf_failure;
        }

      /* find first non-whitespace character in the line */
      next_token = strspn ( linebuf, " \t\r\n");
      str_index  = linebuf + next_token;

      if ( str_index[0] == '\0' || str_index[0] == '#')
        continue; /* empty line or comment line is skipped */

      fopt = str_index;

      /* truncate fopt at the end of the first non-valid character */
      next_token = strcspn (fopt, " \t\r\n=");

      if (fopt[next_token] == '\0') /* the line is over */
        {
          farg  = NULL;
          equal = 0;
          goto noarg;
        }

      /* remember if equal sign is present */
      equal = (fopt[next_token] == '=');
      fopt[next_token++] = '\0';

      /* advance pointers to the next token after the end of fopt */
      next_token += strspn (fopt + next_token, " \t\r\n");
      /* check for the presence of equal sign, and if so, skip it */
      if ( !equal )
        if ((equal = (fopt[next_token] == '=')))
          {
            next_token++;
            next_token += strspn (fopt + next_token, " \t\r\n");
          }
      str_index  += next_token;

      /* find argument */
      farg = str_index;
      if ( farg[0] == '\"' || farg[0] == '\'' )
        { /* quoted argument */
          str_index = strchr (++farg, str_index[0] ); /* skip opening quote */
          if (! str_index)
            {
              fprintf
                (stderr,
                 "%s:%s:%d: unterminated string in configuration file\n",
                 PARSER_PACKAGE, filename, line_num);
              result = EXIT_FAILURE;
              goto conf_failure;
            }
        }
      else
        { /* read up the remaining part up to a delimiter */
          next_token = strcspn (farg, " \t\r\n#\'\"");
          str_index += next_token;
        }

      /* truncate farg at the delimiter and store it for further check */
      delimiter = *str_index, *str_index++ = '\0';

      /* everything but comment is illegal at the end of line */
      if (delimiter != '\0' && delimiter != '#')
        {
          str_index += strspn(str_index, " \t\r\n");
          if (*str_index != '\0' && *str_index != '#')
            {
              fprintf
                (stderr,
                 "%s:%s:%d: malformed string in configuration file\n",
                 PARSER_PACKAGE, filename, line_num);
              result = EXIT_FAILURE;
              goto conf_failure;
            }
        }

    noarg:
      ++my_argc;
      len = strlen(fopt);

      strcat (my_argv, len > 1 ? "--" : "-");
      strcat (my_argv, fopt);
      if (len > 1 && ((farg &&*farg) || equal))
          strcat (my_argv, "=");
      if (farg && *farg)
          strcat (my_argv, farg);

      cmd_line_list_tmp = (struct line_list *) malloc (sizeof (struct line_list));
      cmd_line_list_tmp->next = cmd_line_list;
      cmd_line_list = cmd_line_list_tmp;
      cmd_line_list->string_arg = gengetopt_strdup(my_argv);
    } /* while */

  ++my_argc; /* for program name */
  my_argv_arg = (char **) malloc((my_argc+1) * sizeof(char *));
  cmd_line_list_tmp = cmd_line_list;
  for (i = my_argc - 1; i >= 0; --i) {
    my_argv_arg[i] = cmd_line_list_tmp->string_arg;
    cmd_line_list_tmp = cmd_line_list_tmp->next;
  }
  my_argv_arg[my_argc] = 0;

  additional_error = (char *)malloc(strlen(filename) + strlen(ADDITIONAL_ERROR) + 1);
  strcpy (additional_error, ADDITIONAL_ERROR);
  strcat (additional_error, filename);
  result =
    parser_internal (my_argc, my_argv_arg, args_info, override, initialize, check_required, additional_error);

  free (additional_error);
  free (my_argv_arg);

conf_failure:
  if (file)
    fclose(file);

  free_cmd_list();
  if (result == EXIT_FAILURE)
    {
      parser_free (args_info);
      exit (EXIT_FAILURE);
    }
  
  return result;
}
