/* options.h */

/* File autogenerated by gengetopt version 2.18  */

#ifndef OPTIONS_H
#define OPTIONS_H

/* If we use autoconf.  */
#ifdef HAVE_CONFIG_H
#include "config.h"
#endif

#ifdef __cplusplus
extern "C" {
#endif /* __cplusplus */

#ifndef PARSER_PACKAGE
#define PARSER_PACKAGE PACKAGE
#endif

#ifndef PARSER_VERSION
#define PARSER_VERSION VERSION
#endif

struct icbus_conf
{
  const char *help_help; /* Print help and exit help description.  */
  const char *version_help; /* Print version and exit help description.  */
  char * tty_arg;	/* Choose the tty to use as bus (default='/dev/ttyS0').  */
  char * tty_orig;	/* Choose the tty to use as bus original value given at command line.  */
  const char *tty_help; /* Choose the tty to use as bus help description.  */
  int rs485_arg;	/* Set this to enable/disable RS485-Mode.  */
  char * rs485_orig;	/* Set this to enable/disable RS485-Mode original value given at command line.  */
  const char *rs485_help; /* Set this to enable/disable RS485-Mode help description.  */
  int saveconf_flag;	/* Save the actual configuration to a file (default=off).  */
  const char *saveconf_help; /* Save the actual configuration to a file help description.  */
  char * conffile_arg;	/* The Configurationfile to use (default='/etc/icbus.conf').  */
  char * conffile_orig;	/* The Configurationfile to use original value given at command line.  */
  const char *conffile_help; /* The Configurationfile to use help description.  */
  int detach_flag;	/* Detach from calling terminal (default=off).  */
  const char *detach_help; /* Detach from calling terminal help description.  */
  
  int help_given ;	/* Whether help was given.  */
  int version_given ;	/* Whether version was given.  */
  int tty_given ;	/* Whether tty was given.  */
  int rs485_given ;	/* Whether rs485 was given.  */
  int saveconf_given ;	/* Whether saveconf was given.  */
  int conffile_given ;	/* Whether conffile was given.  */
  int detach_given ;	/* Whether detach was given.  */

} ;

extern const char *icbus_conf_purpose;
extern const char *icbus_conf_usage;
extern const char *icbus_conf_help[];

int parser (int argc, char * const *argv,
  struct icbus_conf *args_info);
int parser2 (int argc, char * const *argv,
  struct icbus_conf *args_info,
  int override, int initialize, int check_required);
int parser_file_save(const char *filename,
  struct icbus_conf *args_info);

void parser_print_help(void);
void parser_print_version(void);

void parser_init (struct icbus_conf *args_info);
void parser_free (struct icbus_conf *args_info);

int parser_configfile (char * const filename,
  struct icbus_conf *args_info,
  int override, int initialize, int check_required);

int parser_required (struct icbus_conf *args_info,
  const char *prog_name);


#ifdef __cplusplus
}
#endif /* __cplusplus */
#endif /* OPTIONS_H */
