#ifndef __ICLIB_READ_CONFIG_H
#define __ICLIB_READ_CONFIG_H

/**
 * This function is used together with gengetopt. It first tries to read
 * the parameters, and afterwards writes and reads a configuration file.
 *
 * Your .ggo file has to define at least the following parameters:
 * 	option "saveconf" ... flag off
 * 	option "conffile" ... string default="..."
 *
 * The prototype generated is
 * 	int read_config(int argc, char **argv, conftype *conf);
 */
#define read_config_decl(conftype) \
	int read_config(int argc, char **argv, conftype *conf) {\
		int ret, sg, cg; \
		ret = parser2(argc, argv, conf, 1, 1, 0); \
		if(ret < 0) { \
			return ret; \
		} \
		if(conf->saveconf_flag) { \
			conf->saveconf_flag = 0; \
			sg = conf->saveconf_given; \
			cg = conf->conffile_given; \
			conf->saveconf_given = 0; \
			conf->conffile_given = 0; \
			parser_file_save(conf->conffile_arg, conf); \
			conf->saveconf_given = sg; \
			conf->conffile_given = cg; \
		} \
		return parser_configfile(conf->conffile_arg, conf, 0, 0, 1); \
	}

#endif
