#include <sys/ioctl.h>
#include <sys/syscall.h>
#include <linux/ioctl.h>
#include <linux/serial.h>
#include <asm/ioctls.h>

#define TIOCGRS485      0x542E
#define TIOCSRS485      0x542F

int my_ioctl(int fh, unsigned long int cmd, void *arg) {
	return ioctl(fh, cmd, arg);
}

int setrs485(int fh, int enable) {
	struct serial_rs485 rs = {};
	if(enable) {
		rs.flags = SER_RS485_ENABLED | SER_RS485_RTS_ON_SEND;
		rs.delay_rts_before_send = 0;
	}
	if(my_ioctl( fh, TIOCSRS485, &rs) < 0) {
		return -1;
	}
	return 0;
}
